//+=========================================================================================================+\\
//|			Made by..																						|\\
//|		   ____   ____  _ 				 __ 		 _ 														|\\
//|		  |_  _| |_  _|(_)              [  |        / |														|\\
//|		    \ \   / /  __   .--.   .--.  | |  ,--. `| |-' .--.   _ .--.										|\\
//|			 \ \ / /  [  | ( (`\]/ .'`\ \| | `'_\ : | | / .'`\ \[ `/'`\]									|\\
//|			  \ ' /    | |  `'.'.| \__. || | // | |,| |,| \__. | | |										|\\
//|			   \_/    [___][\__) )'.__.'[___]\'-;__/\__/ '.__.' [___]										|\\
//|								BL_ID: 20490																|\\
//|				Forum Profile: http://forum.blockland.us/index.php?action=profile;u=40877;                  |\\
//|																											|\\
//+=========================================================================================================+\\

if(!isObject(addCustomBanGui))
	exec("./addCustomBanGui.gui");

//Fix any integers
function fixNumber(%stringorwhatever, %min, %max, %default, %floatLenthVal)
{
	%floatLenthVal = mFloor(%floatLenthVal);
	if(%max $= "")
		%noMax = true;
	else
		%max = mFloatLength(%max, %floatLenthVal);

	if(%min $= "")
		%noMin = true;
	else
		%min = mFloatLength(%min, %floatLenthVal);

	%num = mFloatLength(%stringorwhatever, %floatLenthVal);

	if(%num > %max && !%noMax)
		%num = %max;

	if(%num < %min && !%noMin)
	{
		if(%num == 0)
			%num = %default;
		else
			%num = %min;
	}

	if(%stringorwhatever == 0)
		%num = mFloor(%num); //We don't need a 0.00-...
	return %num;
}

function lstAdminPlayerList::findNameByBL_ID(%this, %BL_ID)
{
	if(%this.rowCount() <= 0)
		return;
	for(%i=0;%i<%this.rowCount();%i++)
	{
		%RowText = %this.getRowText(%i);
		if(getField(%RowText, 1) == %BL_ID)
			return getField(%RowText, 0);
	}
}

package addBanModifier
{
	function BrickManGui::clickBan(%this)
	{
		if(isObject(addCustomBanGui))
		{
			%sel = BrickMan_list.getSelectedID();
			%selRow = BrickMan_list.getRowNumByID(%sel);
			%selText = BrickMan_list.getRowText(%selRow);
			addCustomBanGui.victimBL_ID = getField(%selText, 0);
			AddCustomBan_BLID.setValue(addCustomBanGui.victimBL_ID);
			addCustomBanGui.victimName = getField(%selText, 1);
			addCustomBanGui.victimID = %sel;
			addCustomBan_Window.setText("Custom Ban");
			if(%sel != -1)
				addCustomBan_Window.setText("Custom Ban - " @ addCustomBanGui.victimName);
			canvas.pushDialog(addCustomBanGui);
			return;
		}
		Parent::clickBan(%this);
	}

	function AdminGui_BanPlayer()
	{
		if(isObject(addCustomBanGui))
		{
			%sel = lstAdminPlayerList.getSelectedID();
			%selRow = lstAdminPlayerList.getRowNumByID(%sel);
			%selText = lstAdminPlayerList.getRowText(%selRow);
			addCustomBanGui.victimBL_ID = getField(%selText, 1);
			AddCustomBan_BLID.setValue(addCustomBanGui.victimBL_ID);
			addCustomBanGui.victimName = getField(%selText, 0);
			addCustomBanGui.victimID = %sel;
			addCustomBan_Window.setText("Custom Ban");
			if(%sel != -1)
				addCustomBan_Window.setText("Custom Ban - " @ addCustomBanGui.victimName);
			canvas.pushDialog(addCustomBanGui);
			return;
		}
		Parent::AdminGui_BanPlayer();
	}
};
activatePackage(addBanModifier);

/// Gets the difference in time between two dates.
/// %date1: The first date in MM/DD/YYYY hh:mm:ss format.
/// %date2: The second date in MM/DD/YYYY hh:mm:ss format.
/// Returns: Addition/Subtraction in datetime.
function DT_addTimeString(%date1, %date2)
{
	//%DATE = MONTH DAY YEAR	HOURS MINUTES SECONDS
	%date1 = strReplace(strReplace(%date1, "/", " "), ":", " ");
	%date2 = strReplace(strReplace(%date2, "/", " "), ":", " ");
	%date1 = getWords(%date1, 0, 2) TAB getWords(%date1, 3, 5);
	%date2 = getWords(%date2, 0, 2) TAB getWords(%date2, 3, 5);

	%oldDate1 = getField(%date1, 0);
	%oldTime1 = getField(%date1, 1);
	%oldDate2 = getField(%date2, 0);
	%oldTime2 = getField(%date2, 1);
	
	%newDate = getWord(%oldDate1, 0) + getWord(%oldDate2, 0) SPC getWord(%oldDate1, 1) + getWord(%oldDate2, 1) SPC getWord(%oldDate1, 2) + getWord(%oldDate2, 2);
	%newTime = getWord(%oldTime1, 0) + getWord(%oldTime2, 0) SPC getWord(%oldTime1, 1) + getWord(%oldTime2, 1) SPC getWord(%oldTime1, 2) + getWord(%oldTime2, 2);

	%hours = getWord(%newTime, 0);
	%mins = getWord(%newTime, 1);
	%secs = getWord(%newTime, 2);

	%months = getWord(%newDate, 0);
	%days = getWord(%newDate, 1);
	%years = getWord(%newDate, 2);

	while(%secs >= 60)
	{
		%secs -= 60;
		%mins++;
	}
	
	while(%mins >= 60)
	{
		%mins -= 60;
		%hours++;
	}

	while(%hours >= 24)
	{
		%hours -= 24;
		%days++;
	}

	while(%days >= 30)
	{
		%days -= 30;
		%months++;
	}

	while(%months >= 12)
	{
		%months -= 12;
		if(%months == 0)
			%months = 1;
		%years++;
	}

	if(%hours == 0) %hours = "00";
	if(%mins == 0) %mins = "00";
	if(%secs == 0) %secs = "00";

	if(strLen(%hours) == 1) %hours = "0" @ %hours;
	if(strLen(%mins) == 1) %mins = "0" @ %mins;
	if(strLen(%secs) == 1) %secs = "0" @ %secs;

	if(strLen(%months) == 1) %months = "0" @ %months;
	if(strLen(%days) == 1) %days = "0" @ %days;
	if(strLen(%years) == 1) %years = "0" @ %years;

	%newTime = %hours SPC %mins SPC %secs;
	%newDate = %months SPC %days SPC %years;

	//Don't know how to do days so we will just skip it for now

	%newDate = strReplace(%newDate, " ", "/");
	%newTime = strReplace(%newTime, " ", ":");

	%returnDate = %newDate TAB %newTime;

	if(%newDate $= getWord(getDateTime(), 0))
		%returnDate = %newTime;
	return %returnDate;
}

/// Checks if a year is a leap year.
/// %year: The year to check against.
/// Returns: 1 if the year is a leapyear and 0 otherwise.
function DT_isLeapYear(%year) { return (%year % 100) && !(%year % 4) || !(%year % 400); }

function ParseTimeOfDay(%timeString)
{
	%time = strReplace(%timeString, ":"," ");
	if(getWordCount(%time) != 3)
		return 0;

	%m = " AM";
	%hours = getWord(%time, 0);
	if(%hours >= 12)
	{
		%hours = %hours - 12;
		if(%hours == 0)
		   %hours = 12;
		%m = " PM";
	}
	if(%hours == 0)
		%hours = 12;
	%newTime = %hours @ ":" @ getWord(%time, 1) @ %m;

	return %newTime;
}

function getBanTimeMessage(%addTime)
{
	%str = DT_addTimeString(getDateTime(), "0/0/0" TAB getTimeString(%addTime) @ ":00");
	%time = getField(%str, 1);
	%timeMsg = getField(%str, 0);
	if(%time $= "Today")
	{
		%time = %str;
		%timeMsg = "Today";
	}
	%str = %timeMsg @ " at " @ ParseTimeOfDay(%time);
	%str = %timezone @ %str;
	return %str;
}

function AddCustomBan_BLID::onChange(%this)
{
	%this.setValue(fixNumber(%this.getValue(), 0, 999999, 0));
	addCustomBanGui.victimBL_ID = %this.getValue();
	addCustomBanGui.victimID = -1;
	addCustomBanGui.victimName = "";
	%text = "BL_ID " @ addCustomBanGui.victimBL_ID;
	%name = lstAdminPlayerList.findNameByBL_ID(%this.getValue());
	if(%name !$= "")
	{
		addCustomBanGui.victimName = %name;
		%text = %name;
	}
	addCustomBan_Window.setText("Custom Ban - " @ %text);
}

function addCustomBanGui::ban(%this)
{
	%time["days"] = AddCustomBan_Days.getValue() * 1440;
	%time["hours"] = AddCustomBan_Hours.getValue() * 60;
	%time["minutes"] = AddCustomBan_Minutes.getValue();
	%time = %time["minutes"] + %time["hours"] + %time["days"];
	%timezone = "";
	%str = %timezone @ getBanTimeMessage(%time);

	if(%time <= 0)
	{
		%time = 0;
		%str = "Kicked";
	}
	if(AddCustomBan_Forever.getValue())
	{
		%time = -1;
		%str = "Never";
	}

	%oldValue = addCustomBan_reason.getValue();
	addCustomBan_reason.setValue(addCustomBan_reason.getValue() @ " | Unbanned: " @ %str);
	commandToServer('ban', addCustomBanGui.victimID, addCustomBanGui.victimBL_ID, %time, addCustomBan_reason.getValue());
	addCustomBan_reason.setValue(%oldValue);
}